{% extends "base.html.twig" %}

{% block title -%}
    {{ serie.name }}{% if serie.year %} &ndash; {{ serie.year }}{% endif %}
{%- endblock %}

{% block h1_wrapper %}
    {% if is_granted('ROLE_ADMIN') -%}
        <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="float-right btn btn-danger">
            <i class="fas fa-pen"></i>
        </a>
    {%- endif -%}
    {{ parent() }}
{% endblock %}

{% block content %}

    {{ block('serie_header') }}
    {{ block('serie_kinders') }}
    {{ block('serie_pieces') }}
    {{ block('serie_items') }}
    {{ block('serie_collection') }}
    {{ block('serie_attributes') }}

{% endblock %}

{% block serie_collection %}
    {% import "search.html.twig" as search %}

    {% if serie.collection and serie.collection.series|length > 1 %}
        <h2 class="mt-5">Autres séries liées</h2>
        {{ search.table_series(serie.collection.series, serie.id) }}
    {% endif %}
{% endblock %}

{% block serie_header %}
    {% if serie.description %}
        <p>
            {{- serie.description|nl2br|internalLinks -}}
        </p>
    {% endif %}
{% endblock %}

{% block serie_kinders %}
    {% import "macros.html.twig" as macro %}

    <h2 class="mt-5">
        {%- if collection is defined -%}
            {{ macro.flag(serie.country) }} {{ serie.country }} : {{ serie.name }} &ndash; {{ serie.year }}
            {% if is_granted('ROLE_ADMIN') %}
                <a href="{{ path('admin_series_view', {id: serie.id}) }}" class="ml-5 btn btn-danger">
                    <i class="fas fa-pen"></i>
                </a>
            {% endif %}
        {%- else -%}
            {{ macro.flag(serie.country) }} {{ serie.country }}
        {%- endif -%}
    </h2>
    {% set puzzle = serie.puzzle %}
    {{ block('serie_puzzle') }}
    {% if serie.kinders|length == 0 %}
        <p class="alert alert-secondary">
            Aucune figurine dans cette série 🙁
        </p>
    {% else %}
        {% set maxBpz = serie.maxBpzCount %}
        {% set maxZba = serie.maxZbaCount %}
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Photos</th>
                {%- if maxBpz -%}
                    <th colspan="{{ maxBpz }}">BPZ</th>
                {%- endif -%}
                {%- if maxZba -%}
                    <th colspan="{{ maxZba }}">ZBA</th>
                {%- endif %}
            </tr>
            </thead>
            <tbody>
            {%- for kinder in serie.kinders -%}
                <tr>
                    <td class="text-center">{{ kinder.reference ?: '' }}</td>
                    <td>
                        {{ kinder.name }}
                        {%- if kinder.variante -%}
                            <p class="text-muted variante">
                                Variante : {{ kinder.variante -}}
                            </p>
                        {%- endif -%}
                    </td>
                    <td class="image">
                        {{- macro.images(kinder) -}}
                        {{- macro.status(kinder) -}}
                    </td>
                    {{- _self.td_images(kinder.bpzs, maxBpz) -}}
                    {{- _self.td_images(kinder.zbas, maxZba) -}}
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_puzzle %}
    {% import "macros.html.twig" as macro %}

    {% if puzzle -%}
        <table class="puzzle mt-3 mb-3">
            <tbody>
            {%- for y in 1..puzzle.height -%}
                <tr>
                    {%- for x in 1..puzzle.width -%}
                        {% set kinder = puzzle.kinders[y-1][x-1] ?? none %}
                        {%- if kinder and kinder.image -%}
                            <td class="image">
                                {{- macro.images(kinder) -}}
                            </td>
                        {%- else -%}
                            <td class="empty">
                                <span class="mr-2 ml-2">{{ y }}:{{ x }}</span>
                            </td>
                        {%- endif -%}
                    {%- endfor -%}
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {%- endif %}
{% endblock %}

{% block serie_pieces %}
    {% import "macros.html.twig" as macro %}

    {% if serie.pieces|length %}
        {% set refs = serie|kinderRefs %}
        <h2 class="mt-5">
            {%- if collection is defined %}{{ macro.flag(serie.country) }} {{ serie.country }} : {% endif %}Pièces détachées
        </h2>
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Pièce</th>
                <th>Photos</th>
                <th>Tags</th>
            </tr>
            </thead>
            <tbody>
            {%- for piece in serie.pieces -%}
                <tr>
                    <td class="text-center">{{ piece.reference ?: '' }}</td>
                    <td>{{ refs[piece.reference] ?? '' }}</td>
                    <td>{{ piece.name }}</td>
                    <td class="image">
                        {{- macro.images(piece) -}}
                        {{- macro.status(piece) -}}
                    </td>
                    <td>
                        {{- macro.attributes(piece) -}}
                    </td>
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_items %}
    {% import "macros.html.twig" as macro %}

    {% if serie.items|length %}
        {% set refs = serie|kinderRefs %}
        <h2 class="mt-5">
            {%- if collection is defined %}{{ macro.flag(serie.country) }} {{ serie.country }} : {% endif %}Objets
        </h2>
        <table class="kinders">
            <thead>
            <tr>
                <th>Référence</th>
                <th>Nom</th>
                <th>Objet</th>
                <th>Photos</th>
                <th>Tags</th>
            </tr>
            </thead>
            <tbody>
            {%- for item in serie.items -%}
                <tr>
                    <td class="text-center">{{ item.reference ?: '' }}</td>
                    <td>{{ refs[item.reference] ?? '' }}</td>
                    <td>{{ item.name }}</td>
                    <td class="image">
                        {{- macro.images(item) -}}
                        {{- macro.status(item) -}}
                    </td>
                    <td>
                        {{- macro.attributes(item) -}}
                    </td>
                </tr>
            {%- endfor -%}
            </tbody>
        </table>
    {% endif %}
{% endblock %}

{% block serie_attributes %}
    {% import "macros.html.twig" as macro %}

    {% if serie.attributes|length -%}
        <p class="mt-5 kinder">
            Tags : {{ macro.attributes(serie) -}}
        </p>
    {%- endif %}

    {%- if serie.catalog -%}
        <p class="mt-1 kinder">
            Catalogue :
            <span class="attribute">
                <span>{{ serie.catalog~(serie.catalogPage ? ' - '~serie.catalogPage : '') }}</span>
            </span>
        </p>
    {%- endif -%}
{% endblock %}

{% macro td_images(images, max) -%}
    {% import "macros.html.twig" as macro %}

    {% if max %}
        {% for img in images -%}
            <td class="image">
                {{- macro.images(img) -}}
                {{- macro.status(img) -}}
            </td>
        {% endfor %}
        {% if max - images|length %}
            {%- for i in 1..(max - images|length) -%}
                <td>&nbsp;</td>
            {%- endfor -%}
        {% endif %}
    {% endif %}
{%- endmacro %}